unit Unit_Solv;

interface

uses SysUtils, ComCtrls, Classes, Forms, Dialogs, Unit_Ppal;

procedure ElireCandidatsSeuls;
procedure ExclureCandidat(CandidatExclu:TEnsVal;CazOrigine:TiCaz);
procedure RechercherCandidatsUniques;
procedure RechercherJumeaux;
procedure RechercherInteractions;
procedure RechercherCandidatsIdentiques;
procedure RechercherGroupesMelanges;
procedure RechercherXWing;
procedure RechercherXYWing;
procedure RechercherXYZWing;
procedure ResolutionLogic;
procedure ResolutionParHypotheses;

var
  Progress:boolean;

implementation

uses Unit_Test;

procedure ElireCandidatsSeuls;
//rechercher les cases  un seul candidat afin de l'exclure des autres cases des 3 zones concernes
var
  iCaz:TiCaz;
begin
  for iCaz:=0 to 80 do
  if NbVal(Caz^[iCaz].Cdt)=1
  then ExclureCandidat([PremVal(Caz^[iCaz].Cdt)],iCaz);
end;

procedure ExclureCandidat(CandidatExclu:TEnsVal;CazOrigine:TiCaz);
var
  iCaz:TiCaz;
begin
  //exclure CandidatExclu des 8 autres cases des 3 zones contenant la case CazOrigine
  for iCaz:=0 to 80 do
  if (Caz^[CazOrigine].Zon*Caz^[iCaz].Zon<>[])
  //slection des seules cases ayant au moins 1 zone commune avec c
  and (CandidatExclu<=Caz^[iCaz].Cdt)
  and (iCaz<>CazOrigine)         //la case c  l'origine de l'exclusion est pargne !
  and (NbVal(Caz^[iCaz].Cdt)>1)  //les candidats seuls ne sont pas concerns
  then begin
         Caz^[iCaz].Cdt:=Caz^[iCaz].Cdt-CandidatExclu;
         Progress:=true;
       end;
end;

procedure RechercherCandidatsUniques;
//rechercher les zones dans lesquelles un candidat n'existe que dans une seule case
var
  v:TVal;
  iZon:TiZon;
  iCaz:TiCaz;
begin
  for iZon:=0 to 26 do //parcourir les 27 zones
  if not ZoneComplete(iZon) //exclure les zones entirement compltes
  then for v:=1 to 9 do
       begin
         iCaz:=CandidatUniqueZone(iZon,v);
         if iCaz<>-1
           then begin
                  Caz^[iCaz].Cdt:=[v];
                  Progress:=true;
                end;
       end;
end;

procedure RechercherJumeaux;
//rechercher les rgions dans lesquelles 1 candidat n'existe que dans 2 cases alignes
//revient  rechercher 2 candidats uniques identiques et aligns
//dans 2 interzones colonne/rgion ou ligne/rgion d'une mme rgion
//la 3me interzone ne doit pas accepter le candidat, sauf align avec les 2 premiers ("tripls")
var
  iCaz:TiCaz;
  v:TVal;
  iZon:TiZon;
  cl,n:0..8;
  lg:9..17;
  c,l:0..2;
  trouve:boolean;
begin
  for iZon:=18 to 26 do //parcourir les rgions
  if not ZoneComplete(iZon) //exclure les rgions entirement compltes
  then begin
         cl:=0;lg:=9;
         //recherche de jumeaux par colonne

         for v:=1 to 9 do
         begin
           trouve:=false;
           //2 candidats uniques identiques dans les lignes 0 et 1 de la rgion
           if((CandidatUniqueInterZone(iZon,RegLgn[iZon,0],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegLgn[iZon,1],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegLgn[iZon,1],v)-CandidatUniqueInterZone(iZon,RegLgn[iZon,0],v)=1))
           //dans la mme colonne (2 cases d'une mme colonne et contiges ont des indices diffrents de 1)
           then begin
                  trouve:=true;
                  cl:=ZoneCaz[CandidatUniqueInterZone(iZon,RegLgn[iZon,0],v),0];//indice de colonne
                end;

           //lignes 0 et 2
           if((CandidatUniqueInterZone(iZon,RegLgn[iZon,0],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegLgn[iZon,2],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegLgn[iZon,2],v)-CandidatUniqueInterZone(iZon,RegLgn[iZon,0],v)=2))
           //2 cases d'une mme colonne spares par une 3me ont des indices diffrents de 2)
           then begin
                  trouve:=true;
                  cl:=ZoneCaz[CandidatUniqueInterZone(iZon,RegLgn[iZon,0],v),0];//indice de colonne
                end;

           //lignes 1 et 2
           if((CandidatUniqueInterZone(iZon,RegLgn[iZon,1],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegLgn[iZon,2],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegLgn[iZon,2],v)-CandidatUniqueInterZone(iZon,RegLgn[iZon,1],v)=1))
           then begin
                  trouve:=true;
                  cl:=ZoneCaz[CandidatUniqueInterZone(iZon,RegLgn[iZon,1],v),0];//indice de colonne
                end;

           if trouve
           then begin
                  //Chercher si la valeur trouve est prsente dans les autres colonnes de la rgion
                  for c:=0 to 2 do
                  if(RegCln[iZon,c]<>cl)
                  and(CandidatDansInterZone(iZon,RegCln[iZon,c],v))
                  then trouve:=false;
                  if trouve
                  then begin
                         for n:=0 to 8 do
                         begin
                           iCaz:=IndCaz[cl,n];
                           if(ZoneCaz[iCaz,2]<>iZon)
                           and(v in Caz^[iCaz].Cdt)
                           then begin
                                  Caz^[iCaz].Cdt:=Caz^[iCaz].Cdt-[v];
                                  Progress:=true;
                                end;
                         end;
                       end;

                end;

           //recherche de jumeaux par ligne

           trouve:=false;
           //2 candidats uniques identiques dans les colonnes 0 et 1 de la rgion
           if((CandidatUniqueInterZone(iZon,RegCln[iZon,0],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegCln[iZon,1],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegCln[iZon,1],v)-CandidatUniqueInterZone(iZon,RegCln[iZon,0],v)=9))
           //sur la mme ligne (2 cases d'une mme ligne et contiges ont des indices diffrents de 9)
           then begin
                  trouve:=true;
                  lg:=ZoneCaz[CandidatUniqueInterZone(iZon,RegCln[iZon,0],v),1];//indice de ligne
                end;

           //colonnes 0 et 2
           if((CandidatUniqueInterZone(iZon,RegCln[iZon,0],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegCln[iZon,2],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegCln[iZon,2],v)-CandidatUniqueInterZone(iZon,RegCln[iZon,0],v)=18))
           //2 cases d'une mme ligne spares par une 3me ont des indices diffrents de 18)
           then begin
                  trouve:=true;
                  lg:=ZoneCaz[CandidatUniqueInterZone(iZon,RegCln[iZon,0],v),1];//indice de ligne
                end;

           //colonnes 1 et 2
           if((CandidatUniqueInterZone(iZon,RegCln[iZon,1],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegCln[iZon,2],v)<>-1)
           and(CandidatUniqueInterZone(iZon,RegCln[iZon,2],v)-CandidatUniqueInterZone(iZon,RegCln[iZon,1],v)=9))
           then begin
                  trouve:=true;
                  lg:=ZoneCaz[CandidatUniqueInterZone(iZon,RegCln[iZon,1],v),1];//indice de ligne
                end;

           if trouve
           then begin
                  //Chercher si la valeur trouve est prsente dans les autres lignes de la rgion
                  for l:=0 to 2 do
                  if(RegLgn[iZon,l]<>lg)
                  and(CandidatDansInterZone(iZon,RegLgn[iZon,l],v))
                  then trouve:=false;
                  if trouve
                  then begin
                         for n:=0 to 8 do
                         begin
                           iCaz:=IndCaz[lg,n];
                           if(ZoneCaz[iCaz,2]<>iZon)
                           and(v in Caz^[iCaz].Cdt)
                           then begin
                                  Caz^[iCaz].Cdt:=Caz^[iCaz].Cdt-[v];
                                  Progress:=true;
                                end;
                         end;
                       end;
                end;
         end;
       end;
end;

procedure RechercherInteractions;
//rechercher un candidat absent de 2 interzones colonne/rgion ou ligne/rgion alignes
//la valeur ne doit tre lue dans aucune de ces 2 rgions
var
  z,cl:TiZon;
  v:TVal;
  cln:0..8;
begin
  for z:=0 to 17 do  //parcourir les colonnes et les lignes
  if not ZoneComplete(z)
  then for v:=1 to 9 do   //rechercher les 9 valeurs
       begin
         if not CandidatDansInterZone(ZoneCaz[IndCaz[z,0],2],z,v)
         and not CandidatDansInterZone(ZoneCaz[IndCaz[z,3],2],z,v)
         and(EluDansZone(ZoneCaz[IndCaz[z,0],2],v)=-1)
         and(EluDansZone(ZoneCaz[IndCaz[z,3],2],v)=-1)
         then for cl:=(z div 3)*3 to (z div 3)*3+2 do //parcourir les 3 colonnes/lignes de la rgion
              if cl<>z
              then for cln:=6 to 8 do
                   if v in Caz^[IndCaz[cl,cln]].Cdt
                   then begin
                          Caz^[IndCaz[cl,cln]].Cdt:=Caz^[IndCaz[cl,cln]].Cdt-[v];
                          Progress:=true;
                        end;

         if not  CandidatDansInterZone(ZoneCaz[IndCaz[z,0],2],z,v)
         and not CandidatDansInterZone(ZoneCaz[IndCaz[z,6],2],z,v)
         and(EluDansZone(ZoneCaz[IndCaz[z,0],2],v)=-1)
         and(EluDansZone(ZoneCaz[IndCaz[z,6],2],v)=-1)
         then for cl:=(z div 3)*3 to (z div 3)*3+2 do //parcourir les 3 colonnes/lignes de la rgion
              if cl<>z
              then for cln:=3 to 5 do
                   if v in Caz^[IndCaz[cl,cln]].Cdt
                   then begin
                          Caz^[IndCaz[cl,cln]].Cdt:=Caz^[IndCaz[cl,cln]].Cdt-[v];
                          Progress:=true;
                        end;
                if not  CandidatDansInterZone(ZoneCaz[IndCaz[z,3],2],z,v)
         and not CandidatDansInterZone(ZoneCaz[IndCaz[z,6],2],z,v)
         and(EluDansZone(ZoneCaz[IndCaz[z,3],2],v)=-1)
         and(EluDansZone(ZoneCaz[IndCaz[z,6],2],v)=-1)
         then for cl:=(z div 3)*3 to (z div 3)*3+2 do //parcourir les 3 colonnes/lignes de la rgion
              if cl<>z
              then for cln:=0 to 2 do
                   if v in Caz^[IndCaz[cl,cln]].Cdt
                   then begin
                          Caz^[IndCaz[cl,cln]].Cdt:=Caz^[IndCaz[cl,cln]].Cdt-[v];
                          Progress:=true;
                        end;
       end;
end;

procedure RechercherCandidatsIdentiques;
//rechercher n candidats identiques dans n cases d'une mme zone
var
  iZon:TiZon;
  c1,c2,c3,c:0..8;
begin
  for iZon:=0 to 26 do
  if not ZoneComplete(iZon)
  then begin
         //3 candidats identiques
         for c1:=0 to 6 do
         if NbVal(Caz^[IndCaz[iZon,c1]].Cdt)=3
         then for c2:=c1+1 to 7 do
              if Caz^[IndCaz[iZon,c2]].Cdt=Caz^[IndCaz[iZon,c1]].Cdt
              then for c3:=c2+1 to 8 do
                   if Caz^[IndCaz[iZon,c3]].Cdt=Caz^[IndCaz[iZon,c1]].Cdt
                   then for c:=0 to 8 do
                        if(c<>c1)and(c<>c2)and(c<>c3)
                        and(Caz^[IndCaz[iZon,c]].Cdt*Caz^[IndCaz[iZon,c1]].Cdt<>[])
                        then begin
                               Caz^[IndCaz[iZon,c]].Cdt:=Caz^[IndCaz[iZon,c]].Cdt-Caz^[IndCaz[iZon,c1]].Cdt;
                               Progress:=true;
                             end;
         //2 candidats identiques
         for c1:=0 to 7 do
         if NbVal(Caz^[IndCaz[iZon,c1]].Cdt)=2
         then for c2:=c1+1 to 8 do
              if Caz^[IndCaz[iZon,c2]].Cdt=Caz^[IndCaz[iZon,c1]].Cdt
              then for c:=0 to 8 do
                   if(c<>c1)and(c<>c2)
                   and(Caz^[IndCaz[iZon,c]].Cdt*Caz^[IndCaz[iZon,c1]].Cdt<>[])
                   then begin
                          Caz^[IndCaz[iZon,c]].Cdt:=Caz^[IndCaz[iZon,c]].Cdt-Caz^[IndCaz[iZon,c1]].Cdt;
                          Progress:=true;
                        end;
       end;
end;

procedure RechercherGroupesMelanges;
var
  iZon:Tizon;
  v1,v2,v3:TVal;
  EnsC1,EnsC2,EnsC3:TEnsCaz;
  c1,c2,c3:TiCaz;
begin
  //rechercher n candidats prsents dans n cases de la zone et absents des 9-n autres cases
  for iZon:=0 to 26 do //parcourir les 9 colonnes, 9 lignes, 9 rgions
  if not ZoneComplete(iZon) //exclure les zones entirement compltes
  then begin
         //2 candidats dans 2 cases
         for v1:=1 to 8 do
         begin
           EnsC1:=CasesContenantCdt(iZon,v1);//ensemble des cases de la zone z contenant v1
           if NbCaz(EnsC1)=2 //v1 dans 2 cases
           then for v2:=v1+1 to 9 do
                begin
                  EnsC2:=CasesContenantCdt(iZon,v2);//ensemble des cases de la zone z contenant v2
                  if EnsC2=EnsC1 //v1 et v2 dans les mmes 2 cases
                  then begin
                         c1:=PremCaz(EnsC1);
                         c2:=PremCaz(EnsC1-[PremCaz(EnsC1)]);
                         if(NbVal(Caz^[c1].Cdt)>2)
                         or(NbVal(Caz^[c2].Cdt)>2)
                         //seules les cases c1 et c2 contiennent v1 et v2, les autres candidats de ces 2 cases sont inligibles
                         then begin
                                Progress:=true;
                                Caz^[c1].Cdt:=[v1,v2];
                                Caz^[c2].Cdt:=[v1,v2];
                              end;
                       end;
                end;
         end;
         //3 candidats dans 3 cases
         for v1:=1 to 7 do
         begin
           EnsC1:=CasesContenantCdt(iZon,v1);//ensemble des cases de la zone z contenant v1
           if NbCaz(EnsC1)=3 //v1 dans 3 cases
           then for v2:=v1+1 to 8 do
                begin
                  EnsC2:=CasesContenantCdt(iZon,v2);//ensemble des cases de la zone z contenant v2
                  if EnsC2=EnsC1 //v1 et v2 dans les mmes 3 cases
                  then for v3:=v2+1 to 9 do
                       begin
                         EnsC3:=CasesContenantCdt(iZon,v3);//ensemble des cases de la zone z contenant v3
                         if EnsC3=EnsC1 //v1 et v3 dans les mmes 3 cases
                         then begin
                                c1:=PremCaz(EnsC1);
                                c2:=PremCaz(EnsC1-[PremCaz(EnsC1)]);
                                c3:=PremCaz(EnsC1-[PremCaz(EnsC1-[PremCaz(EnsC1)])]);
                                if(NbVal(Caz^[c1].Cdt)>3)
                                or(NbVal(Caz^[c2].Cdt)>3)
                                or(NbVal(Caz^[c3].Cdt)>3)
                                then begin
                                       Progress:=true;
                                       Caz^[c1].Cdt:=[v1,v2,v3];
                                       Caz^[c2].Cdt:=[v1,v2,v3];
                                       Caz^[c3].Cdt:=[v1,v2,v3];
                                     end;
                              end;
                       end;
                end;
         end;
       end;

end;

procedure RechercherXWing;
//rechercher 4 candidats uniques identiques dans 4 interzones lies
//2 colonnes et 2 lignes, 2 colonnes et 2 rgions, 2 lignes et 2 rgions
var
  v:TVal;
  cl1,cl2,cl,clx,cr1,cr2,lr1,lr2:0..8;
  lg1,lg2,lg,lgx:9..17;
  vide:-1..6;
  r:0..2;
begin
  //recherche colonne/ligne et colonne/rgion
  for cl1:=0 to 8 do
  if not ZoneComplete(cl1) //exclure les colonnes entirement compltes
  then for v:=1 to 9 do
       //rechercher 1 mme candidat unique dans 2 interzones colonne/rgion d'une mme colonne
       //absent de la 3me interzone
       begin
         vide:=-1;
         if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v)<>-1)
         and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v)<>-1)
         and not(CandidatDansInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v))
           //candidats uniques identiques dans rgion haut et rgion centre
         then begin
                //indices des 2 lignes
                lg1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v),1];
                lg2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v),1];
                vide:=6;//1re ligne de l'interzone colonne/rgion dont v est absent
              end;
         if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v)<>-1)
         and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v)<>-1)
         and not(CandidatDansInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v))
           //rgion haut et rgion bas
         then begin
                lg1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v),1];
                lg2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v),1];
                vide:=3;
              end;
         if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v)<>-1)
         and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v)<>-1)
         and not(CandidatDansInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v))
           //rgion centre et rgion bas
         then begin
                lg1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v),1];
                lg2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v),1];
                vide:=0;
              end;
         if vide>-1
         then begin

                //recherche colonne/ligne
                if cl1<6 //cl1 ne doit pas se trouver dans la rgion la +  droite
                then for cl2:=(cl1 div 3+1)*3 to 8 do
                //rechercher une 2nde colonne quivalente depuis la 1re colonne de la 1re rgion  droite
                if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg1-9],2],cl2,v)<>-1)
                  //v est candidat unique dans l'interzone [rgion de la case cl2,lg1-9][cl2]
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg1-9],2],cl2,v),1]=lg1)
                  //sur la ligne lg1
                and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg2-9],2],cl2,v)<>-1)
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg2-9],2],cl2,v),1]=lg2)
                  //sur la ligne lg2
                and not CandidatDansInterzone(ZoneCaz[IndCaz[cl2,vide],2],cl2,v)
                then begin
                       for cl:=0 to 8 do
                       //suppression du candidat v des lignes lg1 et lg2 sauf colonnes cl1 et cl2
                       if(cl<>cl1)and(cl<>cl2)
                       then begin
                              Progress:=(v in Caz^[IndCaz[lg1,cl]].Cdt)
                                      or(v in Caz^[IndCaz[lg2,cl]].Cdt)
                                      or Progress;
                              if v in Caz^[IndCaz[lg1,cl]].Cdt
                              then Caz^[IndCaz[lg1,cl]].Cdt:=Caz^[IndCaz[lg1,cl]].Cdt-[v];
                              if v in Caz^[IndCaz[lg2,cl]].Cdt
                              then Caz^[IndCaz[lg2,cl]].Cdt:=Caz^[IndCaz[lg2,cl]].Cdt-[v];
                          end;
                     end;

                //recherche colonne/rgion
                if cl1 mod 3<>2 //cl1 ne doit pas tre la dernire colonne d'une rgion
                then for cl2:=cl1 to (cl1 div 3)*3+2 do //parcourir les autres colonnes de la rgion
                if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg1-9],2],cl2,v)<>-1)
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg1-9],2],cl2,v),1]<>lg1)
                and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg2-9],2],cl2,v)<>-1)
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lg2-9],2],cl2,v),1]<>lg2)
                and not CandidatDansInterzone(ZoneCaz[IndCaz[cl2,vide],2],cl2,v)
                then begin
                       //suppression du candidat v des 2 interzones ligne/rgion restantes
                       case cl1 mod 3 of
                       0: if cl2=cl1+1 then cl:=cl1+2 else cl:=cl1+1;
                       1: cl:=cl1-1;
                       end;
                       for lg:=9 to 17 do
                       if(lg div 3<>(vide+9) div 3)
                       and(v in Caz^[IndCaz[lg,cl]].Cdt)
                       then begin
                              Caz^[IndCaz[lg,cl]].Cdt:=Caz^[IndCaz[lg,cl]].Cdt-[v];
                              Progress:=true;
                            end;
                     end;
              end;
       end;

  //recherche ligne/colonne et ligne/rgion
  for lg1:=9 to 17 do
  if not ZoneComplete(lg1)
  then for v:=1 to 9 do
       //rechercher 2 candidats uniques identiques dans 2 interzones ligne/rgion d'une mme ligne
       //absent de la 3me interzone
       begin
         vide:=-1;
         if(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v)<>-1)
         and(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v)<>-1)
         and not(CandidatDansInterZone(ZoneCaz[IndCaz[lg1,6],2],lg1,v))
           //candidats uniques identiques dans rgion gauche et rgion centre
         then begin
                //indices des 2 colonnes
                cl1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v),0];
                cl2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v),0];
                vide:=6;
              end;
         if(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v)<>-1)
         and(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,6],2],lg1,v)<>-1)
         and not(CandidatDansInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v))
           //rgion gauche et rgion droite
         then begin
                cl1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v),0];
                cl2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,6],2],lg1,v),0];
                vide:=3;
              end;
         if(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v)<>-1)
         and(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,6],2],lg1,v)<>-1)
         and not(CandidatDansInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v))
           //rgion centre et rgion droite
         then begin
                cl1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v),0];
                cl2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,6],2],lg1,v),0];
                vide:=0;
              end;
         if vide>-1
         then begin

                //recherche ligne/colonne
                if lg1<15 //lg1 ne doit pas se trouver dans la rgion la + en bas
                then for lg2:=(lg1 div 3+1)*3 to 17 do
                //rechercher une 2nde ligne quivalente depuis la 1re ligne de la 1re rgion en-dessous
                if(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl1],2],lg2,v)<>-1)
                  //v est candidat unique dans l'interzone [rgion de la case lg2,cl1][lg2]
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl1],2],lg2,v),0]=cl1)
                  //dans la colonne cl1
                and(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl2],2],lg2,v)<>-1)
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl2],2],lg2,v),0]=cl2)
                  //dans la colonne cl2
                and not CandidatDansInterzone(ZoneCaz[IndCaz[lg2,vide],2],lg2,v)
                then begin
                       for lg:=9 to 17 do
                       //suppression du candidat v des colonnes cl1 et cl2 sauf lignes lg1 et lg2
                       if (lg<>lg1) and (lg<>lg2)
                       then begin
                              Progress:=(v in Caz^[IndCaz[cl1,lg-9]].Cdt)
                                      or(v in Caz^[IndCaz[cl2,lg-9]].Cdt)
                                      or Progress;
                              if v in Caz^[IndCaz[cl1,lg-9]].Cdt
                              then Caz^[IndCaz[cl1,lg-9]].Cdt:=Caz^[IndCaz[cl1,lg-9]].Cdt-[v];
                              if v in Caz^[IndCaz[cl2,lg-9]].Cdt
                              then Caz^[IndCaz[cl2,lg-9]].Cdt:=Caz^[IndCaz[cl2,lg-9]].Cdt-[v];
                            end;
                     end;

                //recherche ligne/rgion
                if lg1 mod 3<>2 //lg1 ne doit pas tre la dernire ligne d'une rgion
                then for lg2:=lg1 to (lg1 div 3)*3+2 do //parcourir les autres lignes de la rgion
                if(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl1],2],lg2,v)<>-1)
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl1],2],lg2,v),0]<>cl1)
                and(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl2],2],lg2,v)<>-1)
                and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cl2],2],lg2,v),0]<>cl2)
                and not CandidatDansInterzone(ZoneCaz[IndCaz[lg2,vide],2],lg2,v)
                then begin
                       //suppression du candidat v des 2 interzones ligne/rgion restantes
                       case lg1 mod 3 of
                       0: if lg2=lg1+1 then lg:=lg1+2 else lg:=lg1+1;
                       1: lg:=lg1-1;
                       end;
                       for cl:=0 to 8 do
                       if(cl div 3<>vide div 3)
                       and(v in Caz^[IndCaz[cl,lg]].Cdt)
                       then begin
                              Caz^[IndCaz[cl,lg-9]].Cdt:=Caz^[IndCaz[cl,lg-9]].Cdt-[v];
                              Progress:=true;
                            end;
                     end;
              end;
       end;

  //recherche rgion/colonne
  for r:=0 to 2 do
  for cl:=0 to 1 do //parcourir les 2 premires colonnes de chaque rgion
  begin
    cl1:=r*3+cl;
    if not ZoneComplete(cl1) //exclure les colonnes entirement compltes
    then for v:=1 to 9 do
         //rechercher 2 candidats uniques identiques dans 2 interzones colonne/rgion d'une mme rgion
         //absent de la 3me interzone
         begin
           vide:=-1;
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v)<>-1)
             //candidats uniques identiques dans rgion haut et rgion centre
           then begin
                  lg1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v),1];
                  lg2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v),1];
                  lr1:=0;
                  lr2:=3;
                  vide:=6;
                end;
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v)<>-1)
             //candidats uniques identiques dans rgion haut et rgion centre
           then begin
                  lg1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v),1];
                  lg2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v),1];
                  lr1:=0;
                  lr2:=6;
                  vide:=3;
                end;
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v)<>-1)
             //candidats uniques identiques dans rgion haut et rgion centre
           then begin
                  lg1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v),1];
                  lg2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v),1];
                  lr1:=3;
                  lr2:=6;
                  vide:=0;
                end;
           for cl2:=cl1+1 to (r+1)*3-1 do
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lr1],2],cl2,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lr2],2],cl2,v)<>-1)
           and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lr1],2],cl2,v),1]<>lg1)
           and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[cl2,lr2],2],cl2,v),1]<>lg2)
           then begin
                  case cl1 mod 3 of
                  0: if cl2=cl1+1 then clx:=cl1+2 else clx:=cl1+1;
                  1: clx:=cl1-1;
                  end;
                  if not(CandidatDansInterzone(ZoneCaz[IndCaz[clx,lr1],2],clx,v))
                  and not(CandidatDansInterzone(ZoneCaz[IndCaz[clx,lr2],2],clx,v))
                  then for lg:=vide to vide+2 do
                       begin
                         Progress:=(v in Caz^[IndCaz[cl1,lg]].Cdt)
                                 or(v in Caz^[IndCaz[cl2,lg]].Cdt)
                                 or Progress;
                         if v in Caz^[IndCaz[cl1,lg]].Cdt
                         then Caz^[IndCaz[cl1,lg]].Cdt:=Caz^[IndCaz[cl1,lg]].Cdt-[v];
                         if v in Caz^[IndCaz[cl2,lg]].Cdt
                         then Caz^[IndCaz[cl2,lg]].Cdt:=Caz^[IndCaz[cl2,lg]].Cdt-[v];
                       end;
                end;
         end;
  end;

  //recherche rgion/ligne
  for r:=0 to 2 do
  for lg:=9 to 17 do //parcourir les 2 premires lignes de chaque rgion
  begin
    lg1:=r*3+lg;
    if not ZoneComplete(lg1) //exclure les lignes entirement compltes
    then for v:=1 to 9 do
         //rechercher 2 candidats uniques identiques dans 2 interzones ligne/rgion d'une mme rgion
         //absent de la 3me interzone
         begin
           vide:=-1;
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v)<>-1)
             //candidats uniques identiques dans rgion gauche et rgion centre
           then begin
                  cl1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v),0];
                  cl2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v),0];
                  cr1:=0;
                  cr2:=3;
                  vide:=6;
                end;
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,0],2],cl1,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v)<>-1)
             //candidats uniques identiques dans rgion haut et rgion centre
           then begin
                  cl1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,0],2],lg1,v),0];
                  cl2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,6],2],lg1,v),0];
                  cr1:=0;
                  cr2:=6;
                  vide:=3;
                end;
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,3],2],cl1,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[cl1,6],2],cl1,v)<>-1)
             //candidats uniques identiques dans rgion haut et rgion centre
           then begin
                  cl1:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,3],2],lg1,v),0];
                  cl2:=ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg1,6],2],lg1,v),0];
                  cr1:=3;
                  cr2:=6;
                  vide:=0;
                end;
           for lg2:=lg1+1 to (r+1)*3-1 do
           if(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cr1],2],lg2,v)<>-1)
           and(CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cr2],2],lg2,v)<>-1)
           and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cr1],2],lg2,v),0]<>cl1)
           and(ZoneCaz[CandidatUniqueInterZone(ZoneCaz[IndCaz[lg2,cr2],2],lg2,v),0]<>cl2)
           then begin
                  case lg1 mod 3 of
                  0: if lg2=lg1+1 then lgx:=lg1+2 else lgx:=lg1+1;
                  1: lgx:=lg1-1;
                  end;
                  if not(CandidatDansInterzone(ZoneCaz[IndCaz[lgx,cr1],2],lgx,v))
                  and not(CandidatDansInterzone(ZoneCaz[IndCaz[lgx,cr2],2],lgx,v))
                  then for cl:=vide to vide+2 do
                       begin
                         Progress:=(v in Caz^[IndCaz[lg1,cl]].Cdt)
                                 or(v in Caz^[IndCaz[lg2,cl]].Cdt)
                                 or Progress;
                         if v in Caz^[IndCaz[lg1,cl]].Cdt
                         then Caz^[IndCaz[lg1,cl]].Cdt:=Caz^[IndCaz[lg1,cl]].Cdt-[v];
                         if v in Caz^[IndCaz[lg2,cl]].Cdt
                         then Caz^[IndCaz[lg2,cl]].Cdt:=Caz^[IndCaz[lg2,cl]].Cdt-[v];
                       end;
                end;
         end;
  end;
end;

procedure RechercherXYWing;
var
  c1,c2,c3:TiCaz;
  v1,v2,v3:TVal;
  c:0..2;
begin
  //rechercher une case c1  2 candidats [v1,v2]
  for c1:=0 to 80 do
  if NbVal(Caz^[c1].Cdt)=2
  then begin
       //rechercher une case c2  2 candidats contenant v1 ou v2 (1 seul des 2)
       //dans la colonne ou ligne contenant c1 mais dans une rgion diffrente

         //recherche dans la colonne contenant c1
         for c2:=0 to 80 do
         if(ZoneCaz[c2,0]=ZoneCaz[c1,0])
         and(NbVal(Caz^[c2].Cdt)=2)
         and(NbVal(Caz^[c2].Cdt*Caz^[c1].Cdt)=1)
         and(ZoneCaz[c2,2]<>ZoneCaz[c1,2])
         then begin
                v1:=PremVal(Caz^[c1].Cdt*Caz^[c2].Cdt);
                v2:=PremVal(Caz^[c1].Cdt-[v1]);
                v3:=PremVal(Caz^[c2].Cdt-[v1]);
                //rechercher une case c3  2 candidats contenant [v2,v3]
                //- soit dans la rgion de c1 ou rgion de c2
                //- soit sur la ligne de c1 ou ligne de c2 mais dans une rgion diffrente
                for c3:=0 to 80 do
                if(NbVal(Caz^[c3].Cdt)=2)
                and(Caz^[c3].Cdt=[v2,v3])
                and(ZoneCaz[c3,0]<>ZoneCaz[c1,0])
                then case(ZoneCaz[c3,2]=ZoneCaz[c1,2])
                       or(ZoneCaz[c3,2]=ZoneCaz[c2,2])of
                     true:  case ZoneCaz[c3,2]=ZoneCaz[c1,2] of
                            true:  begin
                                     Progress:=CandidatDansInterZone(ZoneCaz[c1,2],ZoneCaz[c1,0],v3)
                                            or CandidatDansInterZone(ZoneCaz[c2,2],ZoneCaz[c3,0],v3)
                                            or Progress;
                                     for c:=0 to 2 do
                                     begin
                                       Caz^[IndCaz[ZoneCaz[c1,0],(((ZoneCaz[c1,1]-9)div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c1,0],(((ZoneCaz[c1,1]-9)div 3)*3)+c]].Cdt-[v3];
                                       Caz^[IndCaz[ZoneCaz[c3,0],(((ZoneCaz[c2,1]-9)div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c3,0],(((ZoneCaz[c2,1]-9)div 3)*3)+c]].Cdt-[v3];
                                     end;
                                   end;
                            false: begin
                                     Progress:=CandidatDansInterZone(ZoneCaz[c1,2],ZoneCaz[c3,0],v2)
                                            or CandidatDansInterZone(ZoneCaz[c2,2],ZoneCaz[c1,0],v2)
                                            or Progress;
                                     for c:=0 to 2 do
                                     begin
                                       Caz^[IndCaz[ZoneCaz[c3,0],(((ZoneCaz[c1,1]-9)div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c3,0],(((ZoneCaz[c1,1]-9)div 3)*3)+c]].Cdt-[v2];
                                       Caz^[IndCaz[ZoneCaz[c2,0],(((ZoneCaz[c2,1]-9)div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c2,0],(((ZoneCaz[c2,1]-9)div 3)*3)+c]].Cdt-[v2];
                                     end;
                                   end;
                            end;
                     false: begin
                              if(ZoneCaz[c3,1]=ZoneCaz[c1,1])
                              and(v3 in Caz^[IndCaz[ZoneCaz[c3,0],ZoneCaz[c2,1]-9]].Cdt)
                              then begin
                                     Progress:=true;
                                     Caz^[IndCaz[ZoneCaz[c3,0],ZoneCaz[c2,1]-9]].Cdt
                                   :=Caz^[IndCaz[ZoneCaz[c3,0],ZoneCaz[c2,1]-9]].Cdt-[v3];
                                   end;
                              if(ZoneCaz[c3,1]=ZoneCaz[c2,1])
                              and(v2 in Caz^[IndCaz[ZoneCaz[c3,0],ZoneCaz[c1,1]-9]].Cdt)
                              then begin
                                     Progress:=true;
                                     Caz^[IndCaz[ZoneCaz[c3,0],ZoneCaz[c1,1]-9]].Cdt
                                   :=Caz^[IndCaz[ZoneCaz[c3,0],ZoneCaz[c1,1]-9]].Cdt-[v2];
                                   end;
                            end;
                     end;
              end;

         //recherche dans la ligne contenant c1
         for c2:=0 to 80 do
         if(ZoneCaz[c2,1]=ZoneCaz[c1,1])
         and(NbVal(Caz^[c2].Cdt)=2)
         and(NbVal(Caz^[c2].Cdt*Caz^[c1].Cdt)=1)
         and(ZoneCaz[c2,2]<>ZoneCaz[c1,2])
         then begin
                v1:=PremVal(Caz^[c1].Cdt*Caz^[c2].Cdt);
                v2:=PremVal(Caz^[c1].Cdt-[v1]);
                v3:=PremVal(Caz^[c2].Cdt-[v1]);
                //rechercher une case c3  2 candidats contenant [v2,v3]
                //- soit dans la rgion de c1 ou rgion de c2
                //- soit dans la colonne c1 ou colonne de c2 mais dans une rgion diffrente
                for c3:=0 to 80 do
                if(NbVal(Caz^[c3].Cdt)=2)
                and(Caz^[c3].Cdt=[v2,v3])
                and(ZoneCaz[c3,1]<>ZoneCaz[c1,1])
                then case(ZoneCaz[c3,2]=ZoneCaz[c1,2])
                       or(ZoneCaz[c3,2]=ZoneCaz[c2,2])of
                     true:  case ZoneCaz[c3,2]=ZoneCaz[c1,2] of
                            true:  begin
                                     Progress:=CandidatDansInterZone(ZoneCaz[c1,2],ZoneCaz[c1,1],v3)
                                            or CandidatDansInterZone(ZoneCaz[c2,2],ZoneCaz[c3,1],v3)
                                            or Progress;
                                     for c:=0 to 2 do
                                     begin
                                       Caz^[IndCaz[ZoneCaz[c1,1],((ZoneCaz[c1,0]div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c1,1],((ZoneCaz[c1,0]div 3)*3)+c]].Cdt-[v3];
                                       Caz^[IndCaz[ZoneCaz[c3,1],((ZoneCaz[c2,0]div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c3,1],((ZoneCaz[c2,0]div 3)*3)+c]].Cdt-[v3];
                                     end;
                                   end;
                            false: begin
                                     Progress:=CandidatDansInterZone(ZoneCaz[c1,2],ZoneCaz[c3,1],v2)
                                            or CandidatDansInterZone(ZoneCaz[c2,2],ZoneCaz[c1,1],v2)
                                            or Progress;
                                     for c:=0 to 2 do
                                     begin
                                       Caz^[IndCaz[ZoneCaz[c3,1],((ZoneCaz[c1,0]div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c3,1],((ZoneCaz[c1,0]div 3)*3)+c]].Cdt-[v2];
                                       Caz^[IndCaz[ZoneCaz[c1,1],((ZoneCaz[c2,0]div 3)*3)+c]].Cdt
                                     :=Caz^[IndCaz[ZoneCaz[c1,1],((ZoneCaz[c2,0]div 3)*3)+c]].Cdt-[v2];
                                     end;
                                   end;
                            end;
                     false: begin
                              if(ZoneCaz[c3,0]=ZoneCaz[c1,0])
                              and(v3 in Caz^[IndCaz[ZoneCaz[c3,1],ZoneCaz[c2,0]]].Cdt)
                              then begin
                                     Progress:=true;
                                     Caz^[IndCaz[ZoneCaz[c3,1],ZoneCaz[c2,0]]].Cdt
                                   :=Caz^[IndCaz[ZoneCaz[c3,1],ZoneCaz[c2,0]]].Cdt-[v3];
                                   end;
                              if(ZoneCaz[c3,0]=ZoneCaz[c2,0])
                              and(v2 in Caz^[IndCaz[ZoneCaz[c3,1],ZoneCaz[c1,0]]].Cdt)
                              then begin
                                     Progress:=true;
                                     Caz^[IndCaz[ZoneCaz[c3,1],ZoneCaz[c1,0]]].Cdt
                                   :=Caz^[IndCaz[ZoneCaz[c3,1],ZoneCaz[c1,0]]].Cdt-[v2];
                                   end;
                            end;
                     end;
              end;
       end;
end;

procedure RechercherXYZWing;
var
  c1,c2,c3:TiCaz;
  v1,v2,v3:TVal;
  cl:0..8;
begin
  //rechercher une case c1  3 candidats v1/v2/v3
  for c1:=0 to 80 do
  if NbVal(Caz^[c1].Cdt)=3
  then begin
       //rechercher une case c2  2 candidats v1/v2 dans la mme rgion mais pas la mme colonne/ligne
         for c2:=0 to 80 do
         if(NbVal(Caz^[c2].Cdt)=2)
         and(Caz^[c2].Cdt<=Caz^[c1].Cdt)
         and(ZoneCaz[c2,2]=ZoneCaz[c1,2])
         and(ZoneCaz[c2,0]<>ZoneCaz[c1,0])
         and(ZoneCaz[c2,1]<>ZoneCaz[c1,1])
         then begin
                v1:=PremVal(Caz^[c2].Cdt);
                v2:=PremVal(Caz^[c2].Cdt-[v1]);
                v3:=PremVal(Caz^[c1].Cdt-[v1]-[v2]);
                //rechercher une case c3  2 candidats v2/v3 dans la mme ligne/colonne que c1
                //mais pas la mme rgion
                for c3:=0 to 80 do
                if(Caz^[c3].Cdt=[v2,v3])
                and(ZoneCaz[c3,2]<>ZoneCaz[c1,2])
                then begin
                       //v2 est  enlever des candidats des cases colonne/ligne de c1 rgion de c1 (hors c1)
                       if ZoneCaz[c3,0]=ZoneCaz[c1,0] //c3 dans la mme colonne que c1
                       then for cl:=((ZoneCaz[c1,1]-9)div 3)*3 to ((ZoneCaz[c1,1]-9)div 3)*3+2 do
                            if(cl+9<>ZoneCaz[c1,1])
                            and(v2 in Caz[IndCaz[ZoneCaz[c1,0],cl]].Cdt)
                            then begin
                                   Progress:=true;
                                   Caz[IndCaz[ZoneCaz[c1,0],cl]].Cdt:=Caz[IndCaz[ZoneCaz[c1,0],cl]].Cdt-[v2];
                                 end;
                       if ZoneCaz[c3,1]=ZoneCaz[c1,1] //c3 sur la mme ligne que c1
                       then for cl:=(ZoneCaz[c1,0]div 3)*3 to (ZoneCaz[c1,0]div 3)*3+2 do
                            if(cl<>ZoneCaz[c1,0])
                            and(v2 in Caz[IndCaz[ZoneCaz[c1,1],cl]].Cdt)
                            then begin
                                   Progress:=true;
                                   Caz[IndCaz[ZoneCaz[c1,1],cl]].Cdt:=Caz[IndCaz[ZoneCaz[c1,1],cl]].Cdt-[v2];
                                 end;
                     end;
              end;
       end;
end;

procedure ResolutionLogic;
//Les mthodes de rsolution sont hirarchises de la combinaison prdfinie
//la plus simple (RechercherCandidatsUniques)  la plus complexe (XYZWing)
//Progress=false avant le lancement de ElireCandidatsSeuls
//et renvoie true tant que la mthode utilise est fructueuse
//Si ce n'est pas le cas, on passe  la suivante
//Quand une mthode porte ses fruits, on revient  ElireCandidatsSeuls
//(vite d'utiliser systmatiquement les mthodes les + complexes, inutiles pour les grilles simples)
begin
  repeat
    repeat
      repeat
        repeat
          repeat
            repeat
              repeat
                repeat
                  repeat
                    Progress:=false;
                    ElireCandidatsSeuls;
                  until not Progress;
                  RechercherCandidatsUniques;
                until not Progress;
                RechercherJumeaux;
              until not Progress;
              RechercherInteractions;
            until not Progress;
            RechercherCandidatsIdentiques;
          until not Progress;
          RechercherGroupesMelanges;
        until not Progress;
        RechercherXWing;
      until not Progress;
      RechercherXYWing;
    until not Progress;
    RechercherXYZWing;
  until not Progress;
end;

procedure ResolutionParHypotheses;
var
  Hypo:^THypo;
  iCaz:-1..81;
  NbHypo:byte;
  HypoOK:boolean;
  SensHypo:-1..1;
  NbCdt:2..9;
label
  label0,label1,label2;

  procedure SauveListCdts(NbHypo:byte);
  //enregistre la liste des candidats des 81 cases avant l'hypothse NbHypo
  var
    nC:TiCaz;
  begin
    for nC:=0 to 80 do
    Hypo^[NbHypo].CdtS[nC]:=Caz^[nC].Cdt;
  end;

  procedure RecupListCdts(NbHypo:byte);
  //rcupre la liste des candidats des 81 cases avant l'hypothse NbHypo
  var
    nC:TiCaz;
  begin
    for nC:=0 to 80 do
    Caz^[nC].Cdt:=Hypo^[NbHypo].CdtS[nC];
  end;

  procedure HypoPrec;
  begin
    dec(NbHypo);
    RecupListCdts(NbHypo);
    iCaz:=Hypo^[NbHypo].CazH;
  end;

begin
  new(Hypo);
  try
    NbHypo:=0;
    SensHypo:=-1;
    iCaz:=-1;
    NbCdt:=NbMinCdt;

label0:
    SensHypo:=SensHypo*-1;

label1:
    Application.ProcessMessages;
    if EchecReso then exit;
    repeat
      inc(iCaz,SensHypo);
    until (NbVal(Caz^[iCaz].Cdt)=NbCdt) or (iCaz>80) or (iCaz<0);
    if (iCaz>80) or (iCaz<0) then goto label0;

    inc(NbHypo);
    SauveListCdts(NbHypo);
    Hypo^[NbHypo].CazH:=iCaz;
    Hypo^[NbHypo].CdtH:=Caz[iCaz].Cdt;

label2:
    Application.ProcessMessages;
    if EchecReso then exit;
    case Hypo^[NbHypo].CdtH=[] of
    true : //tous les candidats ont t tests
      begin
        HypoPrec;
        goto label2;
      end;
    false: //il reste des candidats  tester pour cette case
      begin
        //on teste le candidat suivant
        Caz[iCaz].Cdt:=[PremVal(Hypo^[NbHypo].CdtH)];
        //on l'enlve de la liste des candidats  tester
        Hypo^[NbHypo].CdtH:=Hypo^[NbHypo].CdtH-[PremVal(Hypo^[NbHypo].CdtH)];
        ResolutionLogic;
        HypoOk:=GrilleOK;
        case HypoOK of
        true : begin
                 NbCdt:=NbMinCdt;
                 if not GrilleResolue then goto label1;
               end;
        false: begin
                 HypoPrec;
                 goto label2;
               end;
        end;
      end;
    end;
  finally
    dispose(Hypo);
  end;
end;

end.
